<?php

// Obsluha chyb v1.1.1 //
include_once('config.php');

//error_reporting(0);					// Vypni interní obsluhu chyb

function CustomErrorHandler($errno, $errmsg, $filename, $linenum, $vars)
{
  global $Config;
  
  $dt = date('Y-m-d H:i:s');		// časové razítko položky
  $errortype = array(
    1 => "Error",
    2 => "Warning",
    4 => "Parsing Error",
    8 => "Notice",
    16 => "Core Error",
    32 => "Core Warning",
    64 => "Compile Error",
    128 => "Compile Warning",
    256 => "User Error",
    512 => "User Warning",
    1024 => "User Notice"
  );
  $user_errors = E_ALL;  //E_ERROR | E_WARNING | E_PARSE;
  
  if(($user_errors & $errno))
  {
    $err = '# '.$dt.' : '.$errmsg.' on line '.$linenum."\n";
    $Backtrace = debug_backtrace();
    array_shift($Backtrace);
    //array_shift($Backtrace);
    //print_r($Backtrace);
    foreach($Backtrace as $Item)
    {
      $err .= ' '.$Item['file'].'('.$Item['line'].")\t".$Item['function'];
      $arguments = '';
      if(array_key_exists('args',$Item))
      if(is_array($Item['args']))
      foreach($Item['args'] as $Arg)
      {
        if(is_array($Arg)) $arguments .= "'".serialize($Arg)."',";
        else $arguments .= "'".$Arg."',";
      }
      if(strlen($arguments) > 0) $err .= '('.substr($arguments,0,-1).")";
      $err .= "\n";
     
    }
    $err .= "\n";
    //echo('Uvnitř'.$errno);
    if($Config['Web']['ErrorLogFile'] != '')
      error_log($err, 3, $Config['Web']['ErrorLogFile']);				// Ulož do chybového protokolu
	  //$err = "Datum: ".$dt."\nHlášení: ".$errmsg."\nSkript: ".$filename."\nŘádek: ".$linenum;
    // mail($Config['Web']['AdminEmail'], $Config['Web']['Title'].' - Chybové hlášení', $err);		// Pošli mi zprávu (pokud je to kritická chyba)
	  echo('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" xml:lang="cs" lang="cs"><head>'.
    '<meta http-equiv="content-language" content="cs" />'.
    '<meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
    'Došlo k vnitřní chybě!<br /> O chybě byl uvědoměn správce webu a chybu brzy odstraní.<br /><br />');
  	if($Config['Web']['ShowError'] == true) echo('<pre>'.$err.'</pre><br />');			// V případě ladění chybu i zobraz
    echo('</body></html>');
    if((E_ERROR | E_PARSE) & $errno) die(); 
  }// else echo($errmsg.'<br>');
}

set_error_handler('CustomErrorHandler');				// Aktivuj novou obsluhu chyb

?>
